package nl.kallestruik.dtweaks.fakeplayer

import io.netty.channel.ChannelHandler
import io.netty.channel.ChannelHandlerContext
import io.netty.channel.ChannelPipeline
import io.netty.channel.embedded.EmbeddedChannel
import net.minecraft.network.Connection
import net.minecraft.network.protocol.PacketFlow


class FakeConnection(
    packetFlow: PacketFlow
): Connection(packetFlow) {

    init {
        this.channel = FakeChannel()
    }

    override fun setReadOnly() {}

    override fun handleDisconnection() {}

    // We need protocol lib to not get very confused with our fake connection,
    // so we need to create a fake netty pipeline.
    class FakeChannel: EmbeddedChannel() {
        override fun pipeline(): ChannelPipeline {
            val pipeline = newChannelPipeline()
            return pipeline
                .addFirst("encoder", NoopChannelHandler())
                .addFirst("decoder", NoopChannelHandler())
        }
    }

    class NoopChannelHandler : ChannelHandler {
        override fun handlerAdded(ctx: ChannelHandlerContext?) {}

        override fun handlerRemoved(ctx: ChannelHandlerContext?) {}

        @Deprecated("Deprecated in Java")
        override fun exceptionCaught(ctx: ChannelHandlerContext?, cause: Throwable?) {}

    }
}