package nl.kallestruik.dtweaks.managers

import nl.kallestruik.dtweaks.DTweaks
import nl.kallestruik.dtweaks.fakeplayer.FakePlayer
import org.bukkit.Bukkit
import org.bukkit.Location
import org.bukkit.craftbukkit.v1_20_R1.entity.CraftEntity
import org.bukkit.craftbukkit.v1_20_R1.entity.CraftPlayer


/*
    A lot of code in this file is inspired by code from carpet mod.
    Link: https://github.com/gnembon/fabric-carpet
 */
class FakePlayerManager(
    val plugin: DTweaks,
) {
    fun getPlayerByName(name: String): FakePlayer? {
        val player = Bukkit.getPlayer(name)
        if (player == null || !player.isOnline) return null
        return (player as CraftPlayer).handle as? FakePlayer
    }

    fun toFakePlayer(entity: org.bukkit.entity.Entity): FakePlayer? {
        return (entity as CraftEntity).handle as? FakePlayer
    }

    fun spawnFakePlayer(loc: Location, name: String) {
        val player = Bukkit.getPlayer(name)
        if (player != null && player.isOnline) return
        FakePlayer.atLocation(loc, name)
    }

    fun killFakePlayer(name: String) {
        getPlayerByName(name)?.kill()
    }

    fun killAllFakePlayers() {
        for (player in Bukkit.getOnlinePlayers()) {
            if (!player.isOnline) continue
            val fakePlayer = (player as CraftPlayer).handle as? FakePlayer ?: continue
            fakePlayer.kill()
        }
    }
}