package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class AlternativeDispenserRecipe(
    private val plugin: JavaPlugin
): ITweak {
    private var recipeKey = NamespacedKey(plugin, "dispenser")

    override fun getIdentifier(): String = "AlternativeDispenserRecipe"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val dispenserRecipe = ShapedRecipe(recipeKey, ItemStack(Material.DISPENSER))
        dispenserRecipe.shape(" TS", "TDS", " TS")
        dispenserRecipe.setIngredient('T', Material.STICK)
        dispenserRecipe.setIngredient('D', Material.DROPPER)
        dispenserRecipe.setIngredient('S', Material.STRING)

        plugin.server.addRecipe(dispenserRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(recipeKey)
    }
}