package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class CraftableSaddle(
    private val plugin: JavaPlugin
): ITweak {
    private var recipeKey = NamespacedKey(plugin, "saddle")

    override fun getIdentifier(): String = "CraftableSaddle"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val saddleRecipe = ShapedRecipe(recipeKey, ItemStack(Material.SADDLE))
        saddleRecipe.shape("LLL", "S S", "I I")
        saddleRecipe.setIngredient('L', Material.LEATHER)
        saddleRecipe.setIngredient('S', Material.STRING)
        saddleRecipe.setIngredient('I', Material.IRON_INGOT)

        plugin.server.addRecipe(saddleRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(recipeKey)
    }
}