package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class CraftableSponge(
    private val plugin: JavaPlugin
): ITweak {
    private var recipeKey = NamespacedKey(plugin, "sponge")

    override fun getIdentifier(): String = "CraftableSponge"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val spongeRecipe = ShapedRecipe(recipeKey, ItemStack(Material.SPONGE))
        spongeRecipe.shape("KKK", "KDK", "KKK")
        spongeRecipe.setIngredient('K', Material.KELP)
        spongeRecipe.setIngredient('D', Material.YELLOW_DYE)

        plugin.server.addRecipe(spongeRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(recipeKey)
    }
}