package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.RecipeChoice
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class RedyeTerracotta(
    private val plugin: JavaPlugin
): ITweak {
    private val blackRecipeKey = NamespacedKey(plugin, "black_terracotta")
    private val blueRecipeKey = NamespacedKey(plugin, "blue_terracotta")
    private val brownRecipeKey = NamespacedKey(plugin, "brown_terracotta")
    private val cyanRecipeKey = NamespacedKey(plugin, "cyan_terracotta")
    private val grayRecipeKey = NamespacedKey(plugin, "gray_terracotta")
    private val greenRecipeKey = NamespacedKey(plugin, "green_terracotta")
    private val lightBlueRecipeKey = NamespacedKey(plugin, "light_blue_terracotta")
    private val lightGrayRecipeKey = NamespacedKey(plugin, "light_gray_terracotta")
    private val limeRecipeKey = NamespacedKey(plugin, "lime_terracotta")
    private val magentaRecipeKey = NamespacedKey(plugin, "magenta_terracotta")
    private val orangeRecipeKey = NamespacedKey(plugin, "orange_terracotta")
    private val pinkRecipeKey = NamespacedKey(plugin, "pink_terracotta")
    private val purpleRecipeKey = NamespacedKey(plugin, "purple_terracotta")
    private val redRecipeKey = NamespacedKey(plugin, "red_terracotta")
    private val whiteRecipeKey = NamespacedKey(plugin, "white_terracotta")
    private val yellowRecipeKey = NamespacedKey(plugin, "yellow_terracotta")

    private val allTerracotta = RecipeChoice.MaterialChoice(Material.TERRACOTTA, Material.BLACK_TERRACOTTA,
        Material.BLUE_TERRACOTTA, Material.BROWN_TERRACOTTA, Material.CYAN_TERRACOTTA, Material.GRAY_TERRACOTTA,
        Material.GREEN_TERRACOTTA, Material.LIGHT_BLUE_TERRACOTTA,
        Material.LIGHT_GRAY_TERRACOTTA, Material.LIME_TERRACOTTA, Material.MAGENTA_TERRACOTTA,
        Material.ORANGE_TERRACOTTA, Material.PINK_TERRACOTTA, Material.PURPLE_TERRACOTTA, Material.RED_TERRACOTTA,
        Material.WHITE_TERRACOTTA, Material.YELLOW_TERRACOTTA)

    override fun getIdentifier(): String = "RedyeTerracotta"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        addRecipe(blackRecipeKey, Material.BLACK_TERRACOTTA, Material.BLACK_DYE)
        addRecipe(blueRecipeKey, Material.BLUE_TERRACOTTA, Material.BLUE_DYE)
        addRecipe(brownRecipeKey, Material.BROWN_TERRACOTTA, Material.BROWN_DYE)
        addRecipe(cyanRecipeKey, Material.CYAN_TERRACOTTA, Material.CYAN_DYE)
        addRecipe(grayRecipeKey, Material.GRAY_TERRACOTTA, Material.GRAY_DYE)
        addRecipe(greenRecipeKey, Material.GREEN_TERRACOTTA, Material.GREEN_DYE)
        addRecipe(lightBlueRecipeKey, Material.LIGHT_BLUE_TERRACOTTA, Material.LIGHT_BLUE_DYE)
        addRecipe(lightGrayRecipeKey, Material.LIGHT_GRAY_TERRACOTTA, Material.LIGHT_GRAY_DYE)
        addRecipe(limeRecipeKey, Material.LIME_TERRACOTTA, Material.LIME_DYE)
        addRecipe(magentaRecipeKey, Material.MAGENTA_TERRACOTTA, Material.MAGENTA_DYE)
        addRecipe(orangeRecipeKey, Material.ORANGE_TERRACOTTA, Material.ORANGE_DYE)
        addRecipe(pinkRecipeKey, Material.PINK_TERRACOTTA, Material.PINK_DYE)
        addRecipe(purpleRecipeKey, Material.PURPLE_TERRACOTTA, Material.PURPLE_DYE)
        addRecipe(redRecipeKey, Material.RED_TERRACOTTA, Material.RED_DYE)
        addRecipe(whiteRecipeKey, Material.WHITE_TERRACOTTA, Material.WHITE_DYE)
        addRecipe(yellowRecipeKey, Material.YELLOW_TERRACOTTA, Material.YELLOW_DYE)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(blackRecipeKey)
        plugin.server.removeRecipe(blueRecipeKey)
        plugin.server.removeRecipe(brownRecipeKey)
        plugin.server.removeRecipe(cyanRecipeKey)
        plugin.server.removeRecipe(grayRecipeKey)
        plugin.server.removeRecipe(greenRecipeKey)
        plugin.server.removeRecipe(lightBlueRecipeKey)
        plugin.server.removeRecipe(lightGrayRecipeKey)
        plugin.server.removeRecipe(limeRecipeKey)
        plugin.server.removeRecipe(magentaRecipeKey)
        plugin.server.removeRecipe(orangeRecipeKey)
        plugin.server.removeRecipe(pinkRecipeKey)
        plugin.server.removeRecipe(purpleRecipeKey)
        plugin.server.removeRecipe(redRecipeKey)
        plugin.server.removeRecipe(whiteRecipeKey)
        plugin.server.removeRecipe(yellowRecipeKey)
    }

    private fun addRecipe(key: NamespacedKey, output: Material, dye: Material) {
        val recipe = ShapedRecipe(key, ItemStack(output, 8))
        recipe.shape("TTT", "TDT", "TTT")
        recipe.setIngredient('T', allTerracotta)
        recipe.setIngredient('D', dye)

        plugin.server.addRecipe(recipe)
    }
}