package nl.kallestruik.dtweaks.tweaks.croptweaks

import nl.kallestruik.dtweaks.managers.TrampleManager
import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Material
import org.bukkit.entity.Player
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityChangeBlockEvent
import org.bukkit.plugin.java.JavaPlugin

class PlayersCantTrampleCrops(
    private val plugin: JavaPlugin,
    private val trampleManager: TrampleManager
): ITweak, Listener {
    override fun getIdentifier(): String = "PlayersCantTrampleCrops"
    override fun getCategories(): List<String> = listOf("crops", "survival", "players")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onBlockBreak(event: EntityChangeBlockEvent) {
        if (event.block.type != Material.FARMLAND) return
        if (event.entity !is Player) return
        if (trampleManager.trampleEnabled.contains(event.entity.uniqueId)) return
        event.isCancelled = true
    }
}