package nl.kallestruik.dtweaks.tweaks.miscellaneoustweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Material
import org.bukkit.entity.ArmorStand
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.block.BlockFadeEvent
import org.bukkit.event.block.BlockFromToEvent
import org.bukkit.event.player.PlayerInteractAtEntityEvent
import org.bukkit.inventory.EquipmentSlot
import org.bukkit.plugin.java.JavaPlugin

class NoMelting(
    private val plugin: JavaPlugin
): ITweak, Listener {
    override fun getIdentifier(): String = "NoMelting"
    override fun getCategories(): List<String> = listOf("miscellaneous", "survival")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onClickEntity(event: BlockFadeEvent) {
        if (event.block.type != Material.SNOW && event.block.type != Material.ICE)
            return

        event.isCancelled = true
    }
}